# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from .. import utilities, tables

class Notification(pulumi.CustomResource):
    group_names: pulumi.Output[list]
    """
    A list of AutoScaling Group Names
    """
    notifications: pulumi.Output[list]
    """
    A list of Notification Types that trigger
    notifications. Acceptable values are documented [in the AWS documentation here][1]
    """
    topic_arn: pulumi.Output[str]
    """
    The Topic ARN for notifications to be sent through
    """
    def __init__(__self__, resource_name, opts=None, group_names=None, notifications=None, topic_arn=None, __name__=None, __opts__=None):
        """
        Provides an AutoScaling Group with Notification support, via SNS Topics. Each of
        the `notifications` map to a [Notification Configuration][2] inside Amazon Web
        Services, and are applied to each AutoScaling Group you supply.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[list] group_names: A list of AutoScaling Group Names
        :param pulumi.Input[list] notifications: A list of Notification Types that trigger
               notifications. Acceptable values are documented [in the AWS documentation here][1]
        :param pulumi.Input[str] topic_arn: The Topic ARN for notifications to be sent through
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if group_names is None:
            raise TypeError('Missing required property group_names')
        __props__['group_names'] = group_names

        if notifications is None:
            raise TypeError('Missing required property notifications')
        __props__['notifications'] = notifications

        if topic_arn is None:
            raise TypeError('Missing required property topic_arn')
        __props__['topic_arn'] = topic_arn

        super(Notification, __self__).__init__(
            'aws:autoscaling/notification:Notification',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

